variables:
  LIFE_QUOTE: "Life is good"
  PURPOSE: "Simple Django app"
  AUTHOR: "John Doe"
  PLAYWD: ip172-18-0-12-co6m9u2im2rg00943ii0

default:
  image: ubuntu:20.04
  cache:
    paths:
      - ~/.cache/pip/
  before_script:
    - apt -y update
    - apt -y install apt-utils
    - apt -y install net-tools python3.8 python3-pip
    - apt -y upgrade
    - pip3 install -r requirements.txt

stages:
  - test
  - quality
  - package
  - deploy-staging
  - performance

django-tests:
  stage: test
  script:
    - python3 manage.py test

code_quality_job:
  stage: quality
  image: docker:20
  allow_failure: true
  services:
    - docker:20-dind
  before_script:
    - mkdir codequality-results
  script:
    - docker run
        --env CODECLIMATE_CODE="/code"
        --volume "$PWD":/code
        --volume /var/run/docker.sock:/var/run/docker.sock
        --volume /tmp/cc:/tmp/cc
        codeclimate/codeclimate:0.94.1 analyze -f html > ./codequality-results/index.html
  artifacts:
    paths:
      - codequality-results/
  tags:
    - gitlab-org-docker

package_job:
  stage: package
  services:
    - docker:20-dind
  before_script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
  script:
    - sed -i "s/^ALLOWED_HOSTS = \[.*/ALLOWED_HOSTS = ['$PLAYWD-8080.direct.labs.play-with-docker.com', '$PLAYWD_PRD-8080.direct.labs.play-with-docker.com']/" config/settings.py
    - docker build -t $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA .
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
  image: docker:20
  tags:
    - gitlab-org-docker

deploy_staging_job:
  stage: deploy-staging
  image: docker:24
  before_script:
    - export DOCKER_HOST=tcp://$PLAYWD.direct.labs.play-with-docker.com:2375
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - if docker rm -f python-django ; then echo "Existing application stopped"; fi
  script:
    - docker run --name python-django -d -p 8080:8000 -e PURPOSE -e LIFE_QUOTE -e AUTHOR $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
  environment:
    name: staging
    url: http://$PLAYWD-8080.direct.labs.play-with-docker.com/admin

performance_job:
  stage: performance
  image: docker:git
  variables:
    URL: http://$PLAYWD-8080.direct.labs.play-with-docker.com/admin
  services:
    - docker:20-dind
  before_script:
    - echo "true"
  script:
    - apk add --no-cache curl
    - x=1; while [[ "$(curl -s -o /dev/null -w ''%{http_code}'' $URL)" != "200" && "$(curl -s -o /dev/null -w ''%{http_code}'' $URL)" != "301" && $x -le 60 ]]; do sleep 5; echo $(( x++ )); done || false
    - mkdir gitlab-exporter
    - wget -O ./gitlab-exporter/index.js https://gitlab.com/gitlab-org/gl-performance/raw/master/index.js
    - mkdir sitespeed-results
    - docker run --shm-size=1g --rm -v "$(pwd)":/sitespeed.io sitespeedio/sitespeed.io:26.1.0 --plugins.add ./gitlab-exporter --outputFolder sitespeed-results $URL
    - mv sitespeed-results/data/performance.json performance.json
  artifacts:
    paths:
      - sitespeed-results/
  tags:
    - gitlab-org-docker
